/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/

#include "icon.h"

class CBrowserItem : public QListViewItem
{
public:
	CBrowserItem (QListView *pParent, const int iBAB) :
		QListViewItem (pParent, QString ("A %1").arg (iBAB))
	{
		m_pNode = NULL;
	}

	CBrowserItem (QListViewItem *pParent, CNode *pNode) :
		QListViewItem (pParent, QString("A %1").arg(pNode->m_iBAB), pNode->m_strNumber, pNode->m_strName)
	{
		setPixmap(1, pNode->GetPixmap16());
		m_pNode = pNode;

		if (!pNode->WarningText().isEmpty())
			setPixmap (2, IconWarning16());
	}

	CNode *m_pNode;
};

void CDlgBrowser::init()
{

    m_pNetwork = NULL;
    m_listView->addColumn (tr("BAB"), 80);
    m_listView->addColumn (tr("Node"), 50);
    m_listView->addColumn(tr("Name"),170);
	m_listView->setSortColumn(-1);
	m_listView->setRootIsDecorated(true);
	m_listView->setAllColumnsShowFocus(true);
}


void CDlgBrowser::setNetwork( CNetwork *pNetwork )
{
int iBAB=0;
CNode *pNode = NULL;
CBrowserItem *pBABItem=NULL, *pItem=NULL;
    m_pNetwork = pNetwork;
    m_pNetwork->m_listNode.last();
	setCursor (Qt::WaitCursor);
    while ((pNode = m_pNetwork->m_listNode.current()) != NULL)
    {
		if (iBAB != pNode->m_iBAB || pBABItem == NULL)
		{
		    pBABItem = new CBrowserItem (m_listView, pNode->m_iBAB);
			iBAB = pNode->m_iBAB;
		}
		pItem = new CBrowserItem (pBABItem, pNode);
		m_pNetwork->m_listNode.prev();
    }
	setCursor (Qt::ArrowCursor);
}


void CDlgBrowser::onItemChanged( QListViewItem *pItem )
{
CBrowserItem *pItem2=(CBrowserItem*)pItem;
QString str;
	if (pItem2->m_pNode != NULL)
	{
		str = pItem2->m_pNode->AsHTML();
	}

	m_browser->setText(str);
}
